#$Id: Install.py 91 2006-03-09 16:24:08Z taka $
#############################################################################
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.ATCTSmallSample.config import *

def install(self):
    """Install ATCTSmallSample"""

    out = StringIO()

    print >> out, "Installing %s" % PROJECTNAME

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"


    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    for add_type in ('SmallContent',):
        if add_type not in types:
            types.append(add_type)
            factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

    print >> out, "Added %s to portal_factory" % PROJECTNAME

    install_resources(self, out)

    return out.getvalue()


def install_resources(self, out):
    # Install skin
    install_subskin(self, out, GLOBALS)
    print >> out, "Installed skin"

    portal_css = getToolByName(self, 'portal_css')
    portal_css.manage_addStylesheet(id = 'smallcontent.css',
                                    expression = '',
                                    media = 'all',
                                    title = 'inline SmallContent styles',
                                    enabled = True)

    print >> out, "Installed css"



def uninstall(self):
    out = StringIO()

    uninstall_resources(self, out)

    print >> out, "Successfully uninstalled %s." % PROJECTNAME
    return out.getvalue()


def uninstall_resources(self, out):
    """Remove the js and css files from the resource registries"""

    uninstallSkins(self, out)

    print >>out, "Resource files removed"


def uninstallSkins(self, out):
    skins_tool = getToolByName(self, 'portal_skins')

    skins = skins_tool.getSkinSelections()
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = [p.strip() for p in path.split(',') if p]
        while PROJECTNAME in path:
            path.remove(PROJECTNAME)
        skins_tool.addSkinSelection(skin, ','.join(path))

    print >> out, "Uninstalled skin"

